/***************************************************************************
 *            aresponsewindow.h
 *
 *  Sat Apr 23 19:59:22 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _ARESPONSEWINDOW_H
#define _ARESPONSEWINDOW_H

#include <gtk/gtk.h>
#include "icons.h"
#include "basicwindow.h"
#include "settings.h"
#include "processingani.h"
#include "gettext.h"


class autoResponseWindow: public basicWindow
{
	public:
		guint statusToSet;
	
		autoResponseWindow(guint toSet);
		~autoResponseWindow();
	
		void updateStatus(guint state);
	
	protected:
		GtkWidget	*tv,
					*templatesTv,
					*selectFrame,
					*helpWindow,
					*customResponseCheckbox,
					*okayButton,
					*cancelButton;
	
		GtkTreeStore *templatesStore;
	
		GtkWidget* createWindowContent();
		GtkWidget* createTemplatesbar();
		GtkWidget* createButtonbar();
	
		void	  addTemplatesGroupToStore(guint state, gboolean createGroup);
	
		void	  destroyWindowContent();
	
		// callbacks
		static gboolean cb_templatesListClicked(GtkTreeView* tList, GdkEventButton* event, autoResponseWindow* arw);
		static void	 	cb_templatesListActivated(GtkTreeView *tv, GtkTreePath *path, GtkTreeViewColumn *column, autoResponseWindow* arw);
		static void		cb_okayButtonClicked(autoResponseWindow* arw);
		static void		cb_cancelButtonClicked(autoResponseWindow* arw);
		static void		cb_helpButtonClicked(autoResponseWindow* arw);
		static void		cb_customResponseCheckboxClicked(autoResponseWindow* arw);
};



class fetchResponseWindow: public basicWindow
{
	public:
		fetchResponseWindow();
		~fetchResponseWindow();
	
		void fetchAutoResponse();
		void focusWindow();
	
		void escPressed();
	
	protected:
		processingAni	*waitAni;
		GtkWidget		*okayButton,
						*refreshButton,
						*tv,
						*statusImg,
						*statusTxt;	
	
		GtkWidget*	createWindowContent();
		void		destroyWindowContent();
		void		stopFetchAutoResponse(gchar* txt, gchar* stockIcon);
	
		gboolean eventCallback(gint command, gint lastResult, gpointer info);
	
		// callbacks
		static void cb_okayButtonClicked(fetchResponseWindow* frw);
		static void cb_refreshButtonClicked(fetchResponseWindow* frw);
};

#endif /* _ARESPONSEWINDOW_H */
