/*
 * Licq GTK GUI Plugin
 *
 * Copyright (C) 2000, Jon Keating <jon@licq.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

// licq includes can only be included once

/*
#ifndef ICQD_INCLUDE
	#define ICQD_INCLUDE
	
	#include <licq_icqd.h>
	#include "licq_plugin.h"
	#include "licq_log.h"	
#endif */

#include <iostream>

#include "licq_plugin.h"

#include "imbuddy.h"
#include "imuserdaemon.h"
#include "imownerdaemon.h"


// #include "include/regwizard.h"

#include <sys/time.h>
#include <gtk/gtk.h>

int guiArgc; 
char **guiArgv;


const char *LP_Name()
{
	static const char name[] = "icQ'nD";
	return name;
}

const char *LP_Version()
{
	static const char version[] = "0.2";
	return version;
} 

const char *LP_Status()
{
	static const char status[] = "Running";
	return status;
}

const char *LP_Usage()
{
	static const char usage[] = "Usage: licq [ options ] -p icqnd";
	return usage;
}

const char *LP_Description()
{
	static const char desc[] = "GTK-2 GUI";
	return desc;
}

const char *LP_ConfigFile()
{
	return "licq_qnd-gui.conf";
}

bool LP_Init(int argc, char **argv)
{
	// init multi threading stuff
	g_thread_init(NULL);
	gdk_threads_init();
	
	gtk_set_locale();

	textdomain( "icqnd" );

	printf( "Loaded %s language\n", tr( "English" ) );
	
	guiArgc = argc;
	guiArgv = argv;
	
	return( gtk_init_check(&argc, &argv) );
}



int LP_Main(CICQDaemon *icqdaemon)
{
	IMOwner		*program;
		
	setLicqDaemon(icqdaemon);
	IO_installLicqPipe();
	
	program = new IMOwner();
	
	if (!program->errorCode)
		gtk_main();
	else
	{
		fprintf(stderr, "LP_Main: FATAL: GTK couldn't be started!\n");
		return 1;
	}
	
	icqdaemon->Shutdown();		
	
	delete IO_getGroupManager();
	delete program;
	delete settings_getSettings();
		
	return 0;
}
